# NCF CTR SAMPLE #
The purpose of this sample is to demonstrate how to build and train an [MMoE model](https://dl.acm.org/doi/pdf/10.1145/3219819.3220007) with HugeCTR.

## Set Up the HugeCTR Docker Environment ##
You can set up the HugeCTR Docker environment by doing one of the following:
- [Pull the NGC Docker](#pull-the-ngc-docker)
- [Build the HugeCTR Docker Container on Your Own](#build-the-hugectr-docker-container-on-your-own)

### Pull the NGC Docker ###
HugeCTR is available as buildable source code, but the easiest way to install and run HugeCTR is to pull the pre-built Docker image, which is available on the NVIDIA GPU Cloud (NGC). This method provides a self-contained, isolated, and reproducible environment for repetitive experiments.

1. Pull the HugeCTR NGC Docker by running the following command:
   ```bash
   $ docker pull nvcr.io/nvidia/merlin/merlin-training:22.02
   ```
2. Launch the container in interactive mode with the HugeCTR root directory mounted into the container by running the following command:
   ```bash
   $ docker run --gpus=all --rm -it --cap-add SYS_NICE -u $(id -u):$(id -g) -v $(pwd):/hugectr -w /hugectr nvcr.io/nvidia/merlin/merlin-training:22.02
   ```

### Build the HugeCTR Docker Container on Your Own ###
Please refer to [How to Start Your Development](../../docs/hugectr_contributor_guide.md#how-to-start-your-development) to build on your own and set up the Docker container. Make sure that HugeCTR is built and installed to the system path `/usr/local/hugectr` within the Docker container. Launch the container in interactive mode in the same manner as above, and then set the `PYTHONPATH` environment variable inside the Docker container using the following command:
```shell
$ export PYTHONPATH=/usr/local/hugectr/lib:$PYTHONPATH
```
## Download the multi-label synthetic dataset ##
TODO - How will we let users access this dataset for testing? Or is there some public dataset that we can point them to instead?

## Train and validate the MMoE model ##
Once you have either the Norm format dataset in the local directory, train the MMoE model using:
``` shell
$ python mmoe.py
```

If you are using the Parquet format dataset, you can instead use:
``` shell
$ python mmoe_parquet.py
```

## Performance Evaluation ##
TODO - Fill our remaining of the documentation once the joint-loss feature is fully implemented
